import React from "react";
export function createConsumer(Consumer, context) {
    /**
     * SrimerConsumer.
     */
    return class SrimmerConsumer extends React.Component {
        /**
         * initialize bitmask.
         */
        constructor(props) {
            super(props);
            context.register(props.select);
        }
        shouldComponentUpdate() {
            return false;
        }
        /**
         * rednder.
         */
        render() {
            return (React.createElement(Consumer, null, _ => {
                const state = context.getSelectState(this.props.select);
                return (React.createElement(Versioning, { version: state.version }, () => this.props.children(state.state)));
            }));
        }
    };
}
/**
 * Versioning selected state to avoid re-rendering.
 */
class Versioning extends React.Component {
    shouldComponentUpdate(props) {
        return this.props.version !== props.version;
    }
    render() {
        return this.props.children();
    }
}
//# sourceMappingURL=Consumer.js.map