import React from "react";
export function createProvider(Provider, context) {
    /**
     * SrimmerProvider.
     */
    return class SrimmerProvider extends React.Component {
        /**
         * props to state.
         */
        constructor(props) {
            super(props);
            this.state = { state: props.state };
            context.setState(props.state);
            context.subscribe(state => this.setState({ state }));
        }
        /**
         * render.
         */
        render() {
            return (React.createElement(Provider, { value: this.state.state }, this.props.children));
        }
    };
}
//# sourceMappingURL=Provider.js.map